474. ones and zeroes-leetcode

题目:Ones and Zeroes 壹和零?
难度:Medium

In the computer world, use restricted resource you have to generate maximum benefit is what we always want to pursue.

For now, suppose you are a dominator of m 0s and n 1s respectively. On the other hand, there is an array with strings consisting of only 0s and 1s.

Now your task is to find the maximum number of strings that you can form with given m 0s and n 1s. Each 0 and 1 can be used at most once.

Note:

  1. The given numbers of 0s and 1s will both not exceed 100
  2. The size of given string array won’t exceed 600.

Example 1:

Input: Array = {“10”, “0001”, “111001”, “1”, “0”}, m = 5, n = 3
Output: 4

Explanation: This are totally 4 strings can be formed by the using of 5 0s and 3 1s, which are “10,”0001”,”1”,”0”

Example 2:

Input: Array = {“10”, “0”, “1”}, m = 1, n = 1
Output: 2

Explanation: You could form “10”, but then you’d have nothing left. Better form “0” and “1”.

这题的意思就是给定一定数目的0和1,需要返回用这些0和1,最多能够组成列表里的多少个字符串?
看到这一题的第一眼,就想用贪心算法,,毕竟感觉简单,所以首先将列表按照字符串长度从小到大排序,然后一个一个看能不能满足,但是在某些情况下却不能满足,比如[“11”, “01”, “01”], m = 2, n = 2,就不能得到正确的结果。

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
class :
def findMaxForm(self, strs: List[str], m: int, n: int) -> int:
result = 0
strs.sort(key=len)
for i in strs:
x = y = 0
for j in i:
if j == '0':
x += 1
else:
y += 1
m -= x
n -= y
if m >= 0 and n >= 0:
result += 1
else:
m += x
n += y
return result

事实上这题应该用到动态规划(Dynamic programming,DP),按照网上的信息,遇到这种求总数,而不是列出所有情况的题,十有八九都是要用DP来解,而要用DP,最重要的就是要找出递推式,所以需要建立一个二维的DP数组,其中dp[i][j]表示有i个0和j个1时能组成的最多字符串的个数,而对当前遍历到的字符串,首先统计出其中0和1的个数为zeros和ones,然后dp[i-zeros][j-ones]表示当前的i和j减去zeros和ones之前能拼成字符串的个数,那么加上当前的zeros和ones就是当前dp[i][j]可以达到的个数,将其原有数值对比取较大值即可,所以递推式如下:

然后就能很快的写出代码:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
class :
def findMaxForm(self, strs: List[str], m: int, n: int) -> int:
dp = [[0 for col in range(n + 1)] for row in range(m + 1)]
for temp in strs:
zeros = ones = 0
for c in temp:
if c == '0':
zeros += 1
else:
ones += 1
for i in range(m, zeros - 1, -1):
for j in range(n, ones - 1, -1):
dp[i][j] = max(dp[i][j], dp[i - zeros][j - ones] + 1)
return dp[m][n]